/* Generated by wayland-scanner 1.23.1 */

#ifndef WLMAKER_ICON_UNSTABLE_V1_SERVER_PROTOCOL_H
#define WLMAKER_ICON_UNSTABLE_V1_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_wlmaker_icon_unstable_v1 The wlmaker_icon_unstable_v1 protocol
 * @section page_ifaces_wlmaker_icon_unstable_v1 Interfaces
 * - @subpage page_iface_zwlmaker_icon_manager_v1 - Icon Manager
 * - @subpage page_iface_zwlmaker_toplevel_icon_v1 - Toplevel Icon
 * @section page_copyright_wlmaker_icon_unstable_v1 Copyright
 * <pre>
 *
 * Copyright 2023 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * </pre>
 */
struct wl_surface;
struct xdg_toplevel;
struct zwlmaker_icon_manager_v1;
struct zwlmaker_toplevel_icon_v1;

#ifndef ZWLMAKER_ICON_MANAGER_V1_INTERFACE
#define ZWLMAKER_ICON_MANAGER_V1_INTERFACE
/**
 * @page page_iface_zwlmaker_icon_manager_v1 zwlmaker_icon_manager_v1
 * @section page_iface_zwlmaker_icon_manager_v1_desc Description
 *
 * This interface permits clients to register an icon surface for a
 * toplevel. Compositors can use this to present the toplevel in
 * iconified state.
 * @section page_iface_zwlmaker_icon_manager_v1_api API
 * See @ref iface_zwlmaker_icon_manager_v1.
 */
/**
 * @defgroup iface_zwlmaker_icon_manager_v1 The zwlmaker_icon_manager_v1 interface
 *
 * This interface permits clients to register an icon surface for a
 * toplevel. Compositors can use this to present the toplevel in
 * iconified state.
 */
extern const struct wl_interface zwlmaker_icon_manager_v1_interface;
#endif
#ifndef ZWLMAKER_TOPLEVEL_ICON_V1_INTERFACE
#define ZWLMAKER_TOPLEVEL_ICON_V1_INTERFACE
/**
 * @page page_iface_zwlmaker_toplevel_icon_v1 zwlmaker_toplevel_icon_v1
 * @section page_iface_zwlmaker_toplevel_icon_v1_desc Description
 *
 * This interface permits clients to configure a surface representing
 * the toplevel in iconified state.
 * @section page_iface_zwlmaker_toplevel_icon_v1_api API
 * See @ref iface_zwlmaker_toplevel_icon_v1.
 */
/**
 * @defgroup iface_zwlmaker_toplevel_icon_v1 The zwlmaker_toplevel_icon_v1 interface
 *
 * This interface permits clients to configure a surface representing
 * the toplevel in iconified state.
 */
extern const struct wl_interface zwlmaker_toplevel_icon_v1_interface;
#endif

/**
 * @ingroup iface_zwlmaker_icon_manager_v1
 * @struct zwlmaker_icon_manager_v1_interface
 */
struct zwlmaker_icon_manager_v1_interface {
	/**
	 * Destroy the Toplevel Icon Manager.
	 *
	 * Destroys the Toplevel Icon Manager.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * Creates a new Toplevel Icon object.
	 *
	 * Creates a new icon object associated with the given XDG
	 * toplevel.
	 */
	void (*get_toplevel_icon)(struct wl_client *client,
				  struct wl_resource *resource,
				  uint32_t id,
				  struct wl_resource *toplevel,
				  struct wl_resource *surface);
};


/**
 * @ingroup iface_zwlmaker_icon_manager_v1
 */
#define ZWLMAKER_ICON_MANAGER_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_zwlmaker_icon_manager_v1
 */
#define ZWLMAKER_ICON_MANAGER_V1_GET_TOPLEVEL_ICON_SINCE_VERSION 1

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 * @struct zwlmaker_toplevel_icon_v1_interface
 */
struct zwlmaker_toplevel_icon_v1_interface {
	/**
	 * Destroys the Toplevel Icon.
	 *
	 * Destroys the Toplevel Icon.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * Acknowledges configuration sequence.
	 *
	 * Acknowledges configuration sequence.
	 * @param serial the serial of the user event
	 */
	void (*ack_configure)(struct wl_client *client,
			      struct wl_resource *resource,
			      uint32_t serial);
};

#define ZWLMAKER_TOPLEVEL_ICON_V1_CONFIGURE 0

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 */
#define ZWLMAKER_TOPLEVEL_ICON_V1_CONFIGURE_SINCE_VERSION 1

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 */
#define ZWLMAKER_TOPLEVEL_ICON_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 */
#define ZWLMAKER_TOPLEVEL_ICON_V1_ACK_CONFIGURE_SINCE_VERSION 1

/**
 * @ingroup iface_zwlmaker_toplevel_icon_v1
 * Sends an configure event to the client owning the resource.
 * @param resource_ The client's resource
 * @param width New width of the surface
 * @param height New height of the surface
 * @param serial the serial of the user event
 */
static inline void
zwlmaker_toplevel_icon_v1_send_configure(struct wl_resource *resource_, int32_t width, int32_t height, uint32_t serial)
{
	wl_resource_post_event(resource_, ZWLMAKER_TOPLEVEL_ICON_V1_CONFIGURE, width, height, serial);
}

#ifdef  __cplusplus
}
#endif

#endif
